local index = node.LFS.get
local G=_ENV or getfenv()
local lfs_t
if _VERSION == 'Lua 5.1' then
    lfs_t = {
    __index = function(_, name)
        local fn_ut, ba, ma, size, modules = index(name)
        if not ba then
          return fn_ut
        elseif name == '_time' then
          return fn_ut
        elseif name == '_config' then
          local fs_ma, fs_size = file.fscfg()
          return {lfs_base = ba, lfs_mapped = ma, lfs_size = size,
                  fs_mapped = fs_ma, fs_size = fs_size}
        elseif name == '_list' then
          return modules
        else
          return nil
        end
      end,

    __newindex = function(_, name, value) -- luacheck: no unused
        error("LFS is readonly. Invalid write to LFS." .. name, 2)
      end,
    }

    setmetatable(lfs_t,lfs_t)
    G.module       = nil    -- disable Lua 5.0 style modules to save RAM
    package.seeall = nil
else
    lfs_t = node.LFS
end
G.LFS = lfs_t

--*************************************************************
package.loaders[3] = function(module) -- loader_flash
  return lfs_t[module]
end

--*************************************************************
local lf, df, file_exists = loadfile, dofile, file.exists
G.loadfile = function(n)
  local mod = n:match("(.*)%.(l[uc]a?)");
  if file_exists(n) then return lf(n) else return (index(mod) or lf(n)) end
end

G.dofile = function(n)
  local mod = n:match("(.*)%.l[uc]a?");
  local fn  = index(mod)
  if file_exists(n) then return df(n)
  elseif fn then return fn()
  else return df(n) end
end
